<?PHP
require_once( '../../../core.php' );

/** Includes for PHP excel * */
//ini_set('include_path', ini_get('include_path') . ';../../../Classes/');
ini_set('include_path', ini_get('include_path') . ';G:\Classes\\');

include 'PHPExcel.php';
require_once 'PHPExcel/IOFactory.php';
include 'PHPExcel/Writer/Excel2007.php';
require_once 'PHPExcel/Cell/AdvancedValueBinder.php';

#logfile
$logfilename = date('Ymd').'_scm_schedule.log';

# what is the table for queries/scripts
$q1_table		= plugin_table('definitions','Query');
$q2_table		= plugin_table('queue','Query');
$q3_table		= plugin_table('schedule','Query');

# which field separator
$separator = config_get( 'plugin_Query_separator','Query'  );

# load all defined schedules
$query1 = "select * from $q3_table order by schedule_id";
$result1 = db_query_bound($query1);
while ($row1 = db_fetch_array($result1)) {
	# fetch query definition
	$schedule_id	= $row1['schedule_id'];
	$query_id		= $row1['query_id'];
	$target			= $row1['target'];
	$freq			= $row1['frequency'];
	$schedule_name  = $row1['schedule_desc'];

	$fp = fopen($logfilename, 'a');
		fwrite($fp, "start $schedule_name schedule id: $schedule_id query id: $query_id \r\n");
		fclose($fp);
	
	# should we run this schedule today ?
	$weekday	= true;
	$month		= true;
	$week		= true;
	if (date('d') <> '01'){
		$month = false;
	}
	$bookdate = mktime(0, 0, 0, date('m'),date('d'),date('Y'));
	$date_info  = getdate( $bookdate );
	if (($date_info["wday"] == 0) or ($date_info["wday"] == 6) ) {
		$weekday = false;
	}
	if ($date_info["wday"] <> 1)  {
		$week = false;
	}
	if (($freq == 'D') and (!$weekday)){
		continue;
	}
	if (($freq == 'W') and (!$week)){
		continue;
	}
	if (($freq == 'M') and (!$month)){
		continue;
	}

	# let's go
	$query2			= "select * from $q1_table where query_id=$query_id" ;
	$result2		= db_query_bound($query2);
	$row2			= db_fetch_array( $result2 );

	# if we have an additional filter, rebuild query string (only for type Query)
	if ($row2['query_type'] == 'Q'){
		if (!empty($row1['schedule_filter'])){
			$sql = 'select ';
			$sql .= $row2['query_fields'];
			$sql .= ' from ';
			$sql .= $row2['query_tables'] ;
			$where ='';
			if (!empty($row2['query_joins'])){
				$where .= ' where ';
				$where .= $row2['query_joins'];
			}
			if (!empty($row2['query_filters'])){
				if (empty($where)){
					$where .= ' where ';
				} else {
					$where .= ' and ';
				}
				$where .= html_entity_decode($row2['query_filter']);
			}
			if (!empty($row1['schedule_filter'])){
				if (empty($where)){
					$where .= ' where ';
				} else {
					$where .= ' and ';
				}
				$where .= html_entity_decode($row1['schedule_filter']);
			}
			$sql .= $where;
			if (!empty($row2['query_order'])){
				$sql .= ' order by ';
				$sql .= $row2['query_order'];
			}
			if (!empty($row2['query_group'])){
				$sql .= ' group by ';
				$sql .= $row2['query_group'];
			}
		} else {
			$sql = html_entity_decode($row2['query_sql']);
		}
	}

	# action depends on type of script
	$action = $row2['query_type'] ;

	switch($action){
	case "Q":
		# 'Q' means execute query, copy results into $content
		$query3		= $sql;
		$result3	= mysql_query($query3) ;
		if (!$result3) {
    die('Invalid query: ' . mysql_error());
}

		$fields		= 0 ;
		$content	= '';
		while ($row3 = mysql_fetch_row($result3)) {
			# first count the number of fields we have (only once)
			if ($fields == 0) {
				$fields = count($row3) ;
				# now create the headerline
				for ( $i = 0; $i < $fields; $i++ ) {
					if ($i>0){
						$content .= "$separator" ;
					}
					$content .=  mysql_field_name( $result3, $i );
				}
				$content .= "\r\n";
			}
			// data output
			for ($i=0; $i < $fields;$i++){
				if ($i>0){
					$content .= "$separator" ;
				}
				$content .= $row3[$i] ;
			}
			$content .= "\r\n";
		}
		break;
	case "S":
		# 'S' means include script which returns results into $content
		if (!empty($row1['schedule_filter'])){
			$code = html_entity_decode($row1['schedule_filter']);
			$code .= $row2['query_script'];
		} else {
			$code = $row2['query_script'];
		}
		$content = eval(html_entity_decode($code));
		break;
	case "X":
		# 'X' means include script which handles whatever needs to be done
                if (!empty($row1['schedule_filter'])){
			$code = html_entity_decode($row1['schedule_filter']);
			$code .= $row2['query_script'];
		} else {
			$code = $row2['query_script'];
		}
		//$code = $row2['query_script'];
		$content = eval(html_entity_decode($code));
		break;
	}

	if ($action<>'X'){
		# create a unique filename
		$filename = uniqid(mt_rand(), true) . '.csv';

		# save the file to disk
		$fullfile = config_get( 'plugin_Query_download_location','Query'  );
		$fullfile .= $filename;
		$fh = fopen($fullfile, 'w') or die("can't open file");
		fwrite($fh, $content);
		fclose($fh);

		# start sending the file to the recipients
		$ok=mail_it($query_id,$filename, $target,$schedule_name);
		if ($ok) {
			if ( ON == config_get( 'plugin_Query_delete_file' ) ) {
				$fullfile = config_get( 'plugin_Query_download_location','Query'  );
				$fullfile .= $filename;
				unlink($fullfile) ;
			}
		}

	}
		$fp = fopen($logfilename, 'a');
		fwrite($fp, " -- End $schedule_name \r\n");
		fclose($fp);

}

function mail_it($query_id,$filename, $target,$schedule_name) {
	$from = config_get( 'plugin_Query_from_address','Query'  );
	$recipients =  explode(",", $target);
	#now retrieve email addresses and fill the TO variable
	$fields = count($recipients) ;
	$to = '';
	# now create the to address
	for ( $i = 0; $i < $fields; $i++ ) {
		if ($i>0){
			$to .= "," ;
		}
		$username 	= $recipients[$i];
		$domain = strstr($username, '@');
		if (empty($domain)) {
			$userid		= user_get_id_by_name($username);
			$t_email	= user_get_email( $userid );
		} else {
			$t_email = $username ;
		}
		if ($t_email <> ''){
			$to .= $t_email;
		}
	}
	if ($to==''){
		return false;
	}
	$today = date("F j, Y, g:i a");
	$body  = lang_get( 'plugin_query_body' ). " \n\n";
	$body .= $filename. " \n\n";
	$body .= lang_get( 'plugin_query_date' ). " \n\n";
	$body .= $today;
	$fullfile = config_get( 'plugin_Query_download_location','Query'  );
	$fullfile .= $filename;
	// email fields: to, from, subject, and so on
	$subject = "SCM-Report :".$schedule_name;
	$message = date("Y.m.d H:i:s")."\n 1 attachment";
	$headers = "From: $from";
	$headers.="Return-Path:$from\r\n";

	// boundary
	$semi_rand = md5(time());
	$mime_boundary = "==Multipart_Boundary_x{$semi_rand}x";

	// headers for attachment
	$headers .= "\nMIME-Version: 1.0\n" . "Content-Type: multipart/mixed;\n" . " boundary=\"{$mime_boundary}\"";

	// multipart boundary
	$message = "--{$mime_boundary}\n" . "Content-Type: text/plain; charset=\"iso-8859-1\"\n" .
	"Content-Transfer-Encoding: 7bit\n\n" . $message . "\n\n";

	// preparing attachment
	if(is_file($fullfile)){
		$message .= "--{$mime_boundary}\n";
		$fp =    @fopen($fullfile,"rb");
		$data =    @fread($fp,filesize($fullfile));
		@fclose($fp);
		$data = chunk_split(base64_encode($data));
		$message .= "Content-Type: application/octet-stream; name=\"".basename($filename)."\"\n" .
		"Content-Description: ".basename($filename)."\n" .
		"Content-Disposition: attachment;\n" . " filename=\"".basename($filename)."\"; size=".filesize($fullfile).";\n" .
		"Content-Transfer-Encoding: base64\n\n" . $data . "\n\n";
	} else {
		return false;
	}
	$returnpath = "-f" . $from;
	$ok = mail($to, $subject, $message, $headers, $returnpath);
	return $ok ;
}